import type { Plugin } from '@umijs/runtime';
import type { IRoute } from '..';
declare type IRouterComponentProps = {
    routes: IRoute[];
    plugin: Plugin;
    history: any;
    ssrProps?: object;
    defaultTitle?: string;
    dynamicImport?: boolean;
    isServer?: boolean;
};
declare type IOpts = {
    rootElement?: string | HTMLElement;
    callback?: () => void;
} & IRouterComponentProps;
export declare function stripBasename(basename: string, pathname: string): string;
/**
 * preload for SSR in dynamicImport
 * exec preload Promise function before ReactDOM.hydrate
 * @param Routes
 */
export declare function preloadComponent(readyRoutes: IRoute[], pathname?: string): Promise<IRoute[]>;
export default function renderClient(opts: IOpts): any;
export {};
